#include once "fbgfx.bi"

#define FBEXT_NoBuiltinInstanciations() 1
#define FBEXT_NO_EXTERNAL_LIBS () -1

#include once "ext/graphics/sprite.bi"
#include once "ext/graphics/manip.bi"
#include once "ext/graphics/bmp.bi"
#include once "ext/graphics/colors.bi"

using ext
using fb

screenres 640,480,32

'magic numbers
const frog_speed as integer = 32
const car_log_sp as integer = 2

'toggle between east and west directions
#define dtoggle(d) ((d) xor 2 )

enum direction explicit
north =0
east
south
west
end enum

#define FROG_DEAD 4
#define FROG_WIN 5

dim frog as gfx.sprite
dim frog_dir as integer

dim car(1 to 4) as gfx.sprite ptr
dim car_dir(1 to 4) as integer

dim logs(1 to 4) as gfx.sprite ptr
dim logs_dir(1 to 4) as integer

dim pads(1 to 5) as gfx.sprite ptr

cls
'create a frog image
var iFrog = gfx.bmp.load("frog.bmp")

frog.init(6)
frog.SetImage(direction.north, iFrog)
frog.RotateFrom(direction.north, direction.east, -90)
frog.RotateFrom(direction.north, direction.south, 180)
frog.RotateFrom(direction.north, direction.west, 90)
frog.SetImage(FROG_DEAD, gfx.grayscale(iFrog))
frog.DuplicateImage(direction.north, FROG_WIN)
gfx.change_color(frog.GetImage(FROG_WIN), &HFF22B14C /'green'/, gfx.colors.gold, true)

var iCar = gfx.bmp.load("beetle.bmp")

car(1) = new gfx.sprite(4)
car(1)->SetImage(direction.east, iCar)
car(1)->SetImage(direction.west, gfx.flipHorizontal( iCar ))

for l as integer = 2 to 4
        car(l) = new gfx.sprite(*(car(1))) 'just a 1 to 1 copy of the car
next

'What rolls down stairs
'alone or in pairs
'rolls over your neighbor's dog?
'what's great for a snack and fits on your back
'it's log, log, log!
var iLogs = gfx.bmp.load("log.bmp")

logs(1) = new gfx.sprite(4)
logs(1)->SetImage(direction.east, iLogs)
logs(1)->SetImage(direction.west, gfx.flipHorizontal( iLogs ))

for l as integer = 2 to 4
        logs(l) = new gfx.sprite(*(logs(1))) 'just a 1 to 1 copy of the log
next

var iPads = gfx.bmp.load("pad.bmp")

pads(1) = new gfx.sprite(1)
pads(1)->SetImage(0, iPads)

for l as integer = 2 to 5
        pads(l) = new gfx.sprite(*(pads(1))) 'and again a 1 to 1 copy
next

'draw background
line (0,0)-(640,480),gfx.colors.orange,bf      'orange display area
line (0,32)-(372,62),gfx.colors.blue,bf       'brown-ish home
line (0,63)-(372,191),gfx.colors.blue,bf  'blue river
line (0,192)-(372,223),gfx.colors.forest_green,bf     'green safe spot
line (0,224)-(372,351),gfx.colors.grey,bf 'grey road
line (0,352)-(372,383),gfx.colors.forest_green,bf     'green start
line (0,384)-(372,415),gfx.colors.orange,bf   'orange display area

'lines on road
line (0,256)-(372,256),gfx.colors.yellow  'yellow lines
line (0,288)-(372,288),gfx.colors.yellow
line (0,320)-(372,320),gfx.colors.yellow

'display text
locate 2,1
color gfx.colors.black, gfx.colors.orange 'black text on orange bg
print "   FROGGER GAME   "

var backGround = imagecreate(640,480,0)
get (0,0)-(639,479),backGround

var reply = ""

'set lily pad positions, only ever needs to be done once
for i as integer = 1 to 5
        pads(i)->position((i-1)*81,35)
next i

do
        reply = ""  'signal to keep going while reply <> "y" or "x"
        frog.position( 170, 357 )
        frog_dir = direction.north

        car(1)->position( 0, 230 )
        car_dir(1) = direction.east
        car(2)->position( 300, 262 )
        car_dir(2) = direction.east
        car(3)->position( 150, 294 )
        car_dir(3) = direction.east
        car(4)->position( 30, 326 )
        car_dir(4) = direction.east

        logs(1)->position( 0, 72 )
        logs_dir(1) = direction.east
        logs(2)->position( 300, 104 )
        logs_dir(2) = direction.east
        logs(3)->position( 150, 136 )
        logs_dir(3) = direction.east
        logs(4)->position( 30, 168 )
        logs_dir(4) = direction.east

        var chosenLog = 0

        var now = 0d

        do
                'used for location testing later
                var temp_cx = -1f
                var temp_cy = -1f

                screenlock()

                'cls
                'draw background
                put (0,0),backGround,pset

                for i as integer = 1 to 5
                        pads(i)->DrawImage 0, , gfx.trans_
                next


                'draw logs under frog
                for i as integer = 1 to 4
                        logs(i)->DrawImage logs_dir(i), , gfx.trans_
                next i

                'draw dead frog if speed = 0 else draw live frog
                if frog_dir = FROG_DEAD then
                        'put (frog.x,frog.y),iFrog,trans  'change to a dead frog sprite later
                        frog.DrawImage frog_dir, , gfx.trans_
                else'alive
                        'put (frog.x,frog.y),iFrog, trans
                        frog.DrawImage frog_dir, , gfx.trans_
                end if

                'draw cars on top of frog
                for i as integer = 1 to 4
                        car(i)->DrawImage car_dir(i), , gfx.trans_
                next i

                locate 50,1
                if frog_dir = FROG_DEAD then
                        print "  ****  FROG DEAD  ****"
                end if

                print " HIT SPACE KEY to start again OR ESC key to END program"

                screenunlock()

                if frog_dir < FROG_DEAD then

                        'update car positions
                        for i as integer = 1 to 4
                                select case car_dir(i)
                                        case direction.east
                                                car(i)->update( car_log_sp, 0 )
                                        case direction.west
                                                car(i)->update( -(car_log_sp), 0 )
                                end select
                        next i

                        'update log positions and frog position if on a log
                        for i as integer = 1 to 4
                                select case logs_dir(i)
                                        case direction.east
                                                logs(i)->update( car_log_sp, 0 )
                                                if chosenLog = i then
                                                        frog.update( (car_log_sp), 0 )
                                                end if
                                        case direction.west
                                                logs(i)->update( -(car_log_sp), 0 )
                                                if chosenLog = i then
                                                        frog.update( -(car_log_sp), 0 )
                                                end if
                                end select
                        next i

                        'reverse car directions if out of bounds
                        for i as integer = 1 to 4
                                car(i)->position(temp_cx, -1)
                                if temp_cx < 0 or temp_cx > 332 then car_dir(i) = dtoggle(car_dir(i))
                                temp_cx = -1
                        next i

                        'reverse logs directions if out of bounds
                        for i as integer = 1 to 4
                                logs(i)->position(temp_cx, -1)
                                if temp_cx < 0 or temp_cx > 312 then logs_dir(i) = dtoggle(logs_dir(i))
                                temp_cx = -1
                        next i

                end if

                frog.position(temp_cx, temp_cy)
                'user input accepted only every 0.25 seconds - feels like the real thing

                if temp_cy < 64 then
                        for i as integer = 1 to 5 'check all 5 pads
                                if frog.isCollided( *(pads(i)) ) then
                                        print "  ****  FROG HOME  ****"
                                        frog_dir = FROG_WIN
                                end if
                        next

                end if

                if timer > (now + 0.25) then

                        if multikey(SC_SPACE) then reply = "y"
                        if multikey(SC_ESCAPE) then reply = "x"

                        if temp_cy > 63 and frog_dir < FROG_DEAD then'test frog hasn't reached home
                                if multikey(SC_DOWN) and temp_cy <352 then
                                        frog.update(0, frog_speed)
                                        now = timer
                                        chosenLog=0
                                        frog_dir = direction.south
                                end if

                                if multikey(sc_up)  then
                                        frog.update(0, -(frog_speed))
                                        frog_dir = direction.north
                                        now = timer
                                        chosenLog=0
                                end if

                                if multikey(SC_right) and temp_cx < 302 then
                                        frog.update(frog_speed, 0)
                                        frog_dir = direction.east
                                        now = timer
                                        chosenLog=0
                                end if

                                if multikey(sc_left) and temp_cx > 10  then
                                        frog.update(-(frog_speed), 0)
                                        frog_dir = direction.west
                                        now = timer
                                        chosenLog = 0
                                end if
                        end if

                end if

                if temp_cy < 352 and temp_cy > 224 then
                        'test for collision with car
                        for i as integer = 1 to 4
                                if frog.isCollided( *(car(i)) ) then frog_dir = FROG_DEAD
                        next i
                end if

                if temp_cy < 192 and temp_cy > 64 then
                        'test collision with a log
                        for i as integer = 1 to 4
                                if frog.isCollided( *(logs(i)) ) then chosenLog = i
                        next i

                        if  chosenLog=0 then
                                locate 1,1
                                print "MISSED LOG"
                                frog_dir = FROG_DEAD
                                sleep
                        end if

                end if

                sleep 10, 1
                screensync

        loop while reply <> "y" and reply <> "x"

loop while reply = "y"

for i as integer = 1 to 4
        delete car(i)
        delete logs(i)
        delete pads(i)
next

delete pads(5)
imagedestroy background

